{% extends "layouts/base.html" %}
{% block pageJS %}
<script>
	window.addEventListener("load", function (event) {
		const dialog    = $("#dialog-error");
		const dialogOkay= $("#dialog-okay");
		const dialogMsg = document.getElementById("dialog-error-msg");
		const form      = document.getElementById("form");
		const btnSubmit = document.getElementById("form-btn-submit");

		form.addEventListener("submit", async function (event) {
			event.preventDefault();
			event.stopImmediatePropagation();
			event.stopPropagation();
			console.log("submitted");
			const response  = await fetch("/auth/api/register", {
				method : "POST",
				body   : new FormData(form)
			});

			if (response.status == 200) {
				// window.location = "/auth/login";
				dialogOkay.modal('toggle');
			}
			else {
				dialogMsg.innerHTML = `${response.statusText}: ${await response.text()}`;
				dialog.modal('toggle');
			}
		});
	});
</script>
{% endblock pageJS %}

{% block pageContent %}
<!-- Material form login -->
<div class="h-100 d-flex justify-content-center align-items-center">
	<div class="card w-50">
		<h5 class="card-header info-color white-text text-center py-4">
			<strong>Register</strong>
		</h5>

		<!--Card content-->
		<div class="card-body px-lg-5 pt-0">
			<!-- Form -->
			<form class="needs-validation" novalidate id="form" 
				action="/auth/api/register" method="POST">
		
				<div class="form-row md-form">
					<label for="form-username">Username</label>
					<input type="text" id="form-username" class="form-control" name="name" pattern="[A-Za-z0-9]{3,}" required>
					<div   class="invalid-feedback">Username must be minimum 3 characters and fulfill [A-Z0-9]</div>
				</div>
		
				<div class="form-row md-form">
					<label for="form-password">Password</label>
					<input type="password" id="form-password" class="form-control" name="password" pattern="[A-Za-z0-9!@#$%^&*]{8,}" required>
					<div   class="invalid-feedback">Password must be at least 8 characters and fulfills [A-Za-z0-9!@#$%^&*]</div>
				</div>

				<div class="form-row">
					<!-- Sign in button -->
					<button class="btn btn-primary btn-rounded btn-block my-4 waves-effect z-depth-0" type="submit" id="form-btn-submit">Register</button>
				</div>
				<!-- Register -->
				<div class="form-row">
					<p>
						<span>Already have an account?</span>
						<a href="/auth/login">Sign in</a>
					</p>
				</div>
			</form>
			<!-- Form -->
		</div>
	</div>
	<!-- Material form login -->
</div>
<!-- Failure Dialog -->
<div class="modal fade" id="dialog-error" tabindex="-1" role="dialog" aria-hidden="true">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<h5 class="modal-title" id="exampleModalLabel">Error Registering</h5>
				<button type="button" class="close" data-dismiss="modal" aria-label="Close">
					<span aria-hidden="true">&times;</span>
				</button>
			</div>
			<div class="modal-body" id="dialog-error-msg">
				Some random message
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
			</div>
		</div>
	</div>
</div>
<!-- Success Dialog -->
<div class="modal fade" id="dialog-okay" tabindex="-1" role="dialog" aria-hidden="true">
	<div class="modal-dialog" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<h5 class="modal-title" id="exampleModalLabel">Registeration Successful</h5>
			</div>
			<div class="modal-body" id="dialog-okay-msg">
				You are now registered. Please proceed to login. Thank you for using my system.
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-secondary" data-dismiss="modal" onclick="window.location=`/auth/login`">Continue to Signin</button>
			</div>
		</div>
	</div>
</div>
{% endblock pageContent %}